libname boiling 'c:\aa\corsi\corso-sas\'; 

data boiling.dat;
infile 'c:\aa\corsi\lab\materiali\boiling.dat';
/* dati originari in: gradi F, inch Hg */
input tempF press_inch;
temp = (tempF - 32) * 5/9;
press = (press_inch * 25.4)/750.062;
label temp = 'temperatura (Celsius)';
label press = 'pressione (bar)';
run;
proc print data=boiling.dat;
var temp press;
run;

proc reg data=boiling.dat gout=boiling.graph;
  model temp = press;
  output out=boiling.reg predicted=pred residual=res;
  plot temp*press;
run;

proc gplot data=boiling.reg;
plot res*press=2;
run;

data boiling.dat;
set boiling.dat;
press2 = press*press;
log_press = log(press);
/* output out=boiling.dat; */
run;

proc print data=boiling.dat;
var temp press press2 log_press;
run;


proc reg data=boiling.dat gout=boiling.graph;
model temp = press press2;
model temp = press log_press /R P;
plot residual.*press ;
output out=boiling.reg predicted=pred residual=res;
run;
