/* 
  esempio di uso di SAS/GRAPH, ripreso dalla documentazione in linea:
  Help >> SAS System Help >> SAS sample programs >> SAS/GRAPH
*/

libname reflib 'C:\aa\corsi\corso-sas'; 
 
    /* set the graphics environment */ 
goptions reset=global gunit=pct border cback=white 
         colors=(black blue green red) 
         ftext=swiss ftitle=swissb htitle=6 htext=4; 
 
   /* create the data set STATS */ 
data reflib.stats; 
   input height weight; 
   datalines; 
69.0  112.5 
56.5   84.0 
65.3   98.0 
62.8  102.5 
63.5  102.5 
57.3   83.0 
59.8   84.5 
62.5  112.5 
62.5   84.0 
59.0   99.5 
51.3   50.5 
64.3   90.0 
56.3   77.0 
66.5  112.0 
72.0  150.0 
64.8  128.0 
67.0  133.0 
57.5   85.0 
; 
 
   /* define title and footnotes */ 
title 'Study of Height vs Weight'; 
footnote1 h=3 j=l ' Source: T. Lewis & L. R. Taylor'; 
footnote2 h=3 j=l '         Introduction to Experimental Ecology' 
          j=r 'GR21N04(a) '; 
 
   /* generate scatter plot */ 
proc gplot data=reflib.stats; 
   plot height*weight; 
run; 
 
footnote1; 
footnote2 h=3 j=r 'GR21N04(b) '; 
 
   /* define symbol characteristics for second output graphic */ 
symbol1 interpol=rcclm95 /* regression analysis with */ 
                         /* confidence limits        */ 
        value=diamond    /* plot symbol              */ 
        height=3         /* plot symbol height       */ 
        cv=red           /* plot symbol color        */ 
        ci=blue          /* regression line color    */ 
        co=green         /* confidence limits color  */ 
        width=2;         /* line width               */ 
 
      /* generate scatter plot with regression */ 
   plot height*weight / haxis=45 to 155 by 10 
                        vaxis=48 to 78 by 6 
                        hminor=1 
                        regeqn; 
run; 
quit; 


