LIBNAME esempi 'c:\aa\corsi\corso-sas\';
goptions reset=global htext=0.25cm;

data esempi.ais;
  infile 'c:\aa\corsi\corso-sas\esempi.dat' firstobs=2;
  input sesso $ sport $ RCC  WCC Hc Hg Ferr BMI SSF Bfat  LBM  Ht  Wt;
  label
    Hc = 'ematocrito'
    Hg = 'emoglobina'
    Bfat = '% grasso'
    Wt = 'peso (kg)'
    Ht = 'altezza (cm)'
    RCC = 'cellule rosse'
    WCC = 'cellule bianche'
    SSF = 'superficie della pelle'
    BMI = 'body mass index (peso/alt^2)'
    ;
run;

* sort data;

proc reg data=esempi.ais;
  model Ht = Wt WCC; 
  by sesso;
  where sport='Row';
  output OUT=esempi.reg PREDICTED=pred RESIDUAL=res;
run;

proc g3d data= esempi.reg;
  scatter Wt * WCC = Ht /color='black' size=0.5;
  scatter Wt * WCC = pred / size=0.5;
run;

proc FREQ data=esempi.ais;
  TABLES sport sesso sesso*sport / chisq;
run;
