libname bank_it 'c:\aa\corsi\corso-sas';
goptions reset=global gunit=pct border cback=white 
         colors=(black blue green red) ctext=green
         ftext=swiss ftitle=swissb htitle=4 htext=2; 
%let anno=1998;
%let cond=y>0 & y<500000;
title1 "Studio Banca d'Italia sulle famiglie italiane, anno &anno"; 
title2 "(sottopopolazione: &cond)";

%macro reg_lin(y,x);
   proc reg data=tempor;
     model &y = &x;
	 output out=temp1 predicted=stimati residual=residui;
   run;
   
   proc gplot data=tempor;
     footnote "regressione quadratica";
     symbol interpol=rq     /* regressione quadratica */
          cv = red          /* colore dei punti */
	      value = diamond   /* simbolo dei punti */ 
		  ci = blue         /* colore retta/curva di regressione */
	      width = 2         /* spessore linee */
          line = 3          /* tipo di linea (continua/tratteggiata...) */
		  ;
     plot &y * &x  / regeqn ;
   run;
%mend reg_lin;
data tempor;
  set bank_it.rfam&anno;
  set bank_it.cfam&anno;
  keep nquest y yl yc cd cn s;
  where &cond;
  label y  = 'reddito disponibile netto'
        yl = 'reddito da lavoro dipendente'
        yc = 'reddito da capitale'
        cd = 'consumi durevoli'
		cn = 'consumi non durevoli' 
		s  = 'risparmio';
run;

%reg_lin(cd,yc)
%reg_lin(cn,yl)

quit;
