/* 
modifica di file esempio-demogr.sas (2002-09-01), tratto da

  SAS Help
    Welcome to the SAS System
      Sample SAS Programs and Applications - SAS Sample Library 
        SAS/STAT Sample Programs 
          Getting Started Example for PROC ACECLUS 
*/
libname  demogr 'c:\aa\corsi\corso-sas\';

data demogr; 
   infile 'c:\aa\corsi\corso-sas\var-demogr.dat';
   input natal mortal mort_inf paese $ :15. @@;
   log_mort = log(mortal); 
   select;
     when (mort_inf < 10) male=0;
     when (mort_inf < 25) male=1;
     when (mort_inf < 50) male=2;
     when (mort_inf < 100) male=3;
     otherwise    male=4;
  end;
  label log_mort = "log(mortalit)"
        mort_inf = "mortalit infantile"
        male = "mortalit infantile raggrupata in classi"
        natal = "natalit"; 
  run;
/* proc fsview data=demogr;
  run;
*/

/* -------------------------------------
   definizione opzioni grafiche
*/
axis1 label=(angle=90 rotate=0) minor=none; 
axis2 minor=none; 
goptions reset=global
     /* colors=(black red green blue yellow magenta); */
  ;
symbol1 color=green width=1 value=triangle height=1; 
symbol2 color=green width=1 value=circle   height=1; 
symbol3 color=blue  width=1 value=square  height=1;
symbol4 color=red   width=1 value=plus    height=1.5;
symbol5 color=red   width=1 value=x       height=2;
proc gplot data=demogr; 
   plot natal * mortal = male / 
      frame cframe=ligr legend=legend1 vaxis=axis1 haxis=axis2; 
run;
proc freq data=demogr;
  tables male;
  run;

proc reg data=demogr;
  model  mort_inf = log_mort;
  plot mort_inf * log_mort ;
  where natal > 20 ;
run;
 
