/* ----- prova 01 ----------------------------------------------------------- */
data a;
	b=212321*12.3312;
	log_b=log(b);
	c=exp(log_b);
run;

proc print data=a;
run;

/* ----- prova 02 ----------------------------------------------------------- */
data una_variabile;
	input y @@;
	cards;
	12 23 43 56 78 56 74 12 43 98 43 96 48 93 47 81 29 54 31 87 65 91 34
	12 34 56 78 41 63 52 48 73 92 48 67 21 46 12 34 67 59 84 21 35 49 67
	;
run;

proc univariate; /* usa i dati dal data step precedente */
	var y;
	histogram y;
run;

/* ----- prova 03 ----------------------------------------------------------- */
data una_variabile;
	input y @@;
	cards;
	12 23 43 56 78 56 74 12 43 98 43 96 48 93 47 81 29 54 31 87 65 91 34
	12 34 56 78 41 63 52 48 73 92 48 67 21 46 12 34 67 59 84 21 35 49 67
	;
run;

proc univariate normaltest; /* vengono effettuati anche i test di normalita' */
	var y;
	histogram y / normal;
	inset nobs mean std; /* # oss, media, sqm */
	qqplot y / normal;
	output out=istogramma   /* crea un dataset di nome "istogramma" coi dati seguenti*/
		min=min max=max nobs=n mean=media std=sqm; /* assegna un nome alle var */
run;

proc print data=istogramma;		/* stampa dei dati */
run;

proc fsprint data=istogramma;	/* altro tipo di stampa dei dati */
run;

/* ----- prova 04 ----------------------------------------------------------- */
data tabella;
	/* - il carattere "$" dopo il nome indica che la variabile e' una stringa
		 altrimenti e' considerata di tipo numerico
	   - ":10" indica che mi servono piu' caratteri degli 8 di default (nel nostro
         caso estendiamo a 10) */
	input cognome $ matricola $ :10. voto @@;
	/* viene assegnata una etichetta alla var voto */
	label voto='voto in trentesimi';
	/* il '.' indica che il dato e' mancante */
	cards;
		rossi		123456/SE	28
		bianchi		234567/SE	21
		verdi		345678/SD	24
		neri		456789/SE	23
		amaranto	567890/SD	30
		viola		678901/SE	.
	;
run;

proc print data=tabella;
	var cognome matricola voto;
run;

proc univariate data=tabella;
	var voto;
	qqplot voto / normal;
run;

/* ----- prova 05 ----------------------------------------------------------- */
libname regioni 'M:\corsi\sc1\sas\lab_02'; /* dir dove poter scrivere i dati su disco */

data regioni.pippo;	/* 'regioni' determina la cartella, 'pippo' e' il nome del file da creare */
	/* lettura dati da un file:
	   "firstobs" riga dalla quale deve iniziare a leggere i dati */
	infile 'M:\corsi\sc1\sas\Stat_comp1\sas\regioni90.dat' firstobs=3;
	/* formato dei dati:
	   nomevar [$]  col1-col2 --> legge la var 'nomevar' dalla colonna 'col1' alla 'col2' */
	input regione $	 1-22
		  E1 		24-26
		  letti1 	28-34
		  E2 		35-38
		  letti2 	41-45
          E3 		48-50
		  letti3	54-58;
run;

proc fsview data=regioni.pippo;
run;

/* ----- prova 06 ----------------------------------------------------------- */
data ditutto;
infile 'M:\corsi\sc1\sas\Stat_comp1\sas\ditutto.dat' firstobs=3;
/* leggi con formato fisso fino alla colonna 136, poi leggi con formato libero
   il nome di 10 caratteri al massimo e poi leggi 4 variabili di nome v1,v2,v3,v4 */
input codice 1-3 sesso$ 4 annon 6-7 titolo 25 statoc 9 @136 nome $ :10. v1-v4;
label
  codice	=	'Codice identificativo'
  annon		=	'Anno di nascita'
  titolo	=	'Titolo di studio'
  statoc	=	'Stato civile'
  nome		=	'Nome dello studente'
  v1		=	'Primo voto'
  v2		=	'Secondo voto'
  v3		=	'Terzo voto'
  v4		=	'Quarto voto';
run;

proc fsview data=ditutto;
run;
