LIBNAME geyser 'M:\corsi\sc1\sas\libs';
GOPTIONS reset=global;

DATA geyser.dat;
  INFILE 'M:\corsi\sc1\sas\datasets\sas\geyser.dat';
  INPUT	d_m		$	1
		d_sec	2-3
				@5
		w;

  secondi = d_sec;
  min= d_m;
  IF(d_sec = '.') THEN secondi=0;
  IF(d_m = "S") THEN min = 2;
  IF(d_m = "M") THEN min = 3;
  IF(d_m = "L") THEN min = 4;
  durata = min + secondi/60;

  SELECT;
  WHEN (d_m = "L" | d_m = "M" | d_m = "S") 
    night=1; 
  OTHERWISE
    night=0;
  END; 
  LABEL 
     durata="durata dell'eruzione (minuti)"
	 w = "tempo di attesa (minuti)";
RUN;

PROC REG DATA=geyser.dat alpha=0.10;
  MODEL durata=w;
  PLOT durata * w / pred conf;
  PLOT residual. * predicted. ;
RUN;

/*
proc fsview data=geyser.dat;
RUN;
*/
PROC SORT DATA=geyser.dat OUT=geyser.sorted;
	BY night;
RUN;

PROC gplot DATA=geyser.sorted;
	PLOT w * durata ;
RUN;

QUIT;

