#----- INTEGRALE ---------------------------------------------------------------
# Calcola un integrale in modo approssimato con runif()
#-------------------------------------------------------------------------------
#I1: f		| funzione da integrare
#I2: from	| estremo inferiore
#I1: to		| estremo superiore
#I1: n		| numero di numeri casuali
#I1: ...	| altri argomenti
#-------------------------------------------------------------------------------
integrale<-function (f,from,to,n=1000,...) {
	abs(to-from)*mean(f(x=runif(n,from,to),...))
}#integrale --------------------------------------------------------------------


#----- KERNPLOT ----------------------------------------------------------------
# Stima la funzione di densita' di un campione tramite il metodo del nucleo
#-------------------------------------------------------------------------------
#I1: x		| vettore campione
#-------------------------------------------------------------------------------
kernplot<-function (x) {
	plot(density(x))
	points(x,rep(0,length(x)),col='red',cex=.5)
}#kernplot ---------------------------------------------------------------------


#----- LOWESSPLOT --------------------------------------------------------------
# Stima la curva di interpolazione tramite la funzione lowess()
# NB: lowess e' una funz. che opera solo in campo lineare
#-------------------------------------------------------------------------------
#I1: x		| vettore campione
#-------------------------------------------------------------------------------
lowessplot<-function (x,y,f=2/3) {
	plot(x,y)
	lines(lowess(x,y,f),col='red')
}#lowessplot -------------------------------------------------------------------



