#Esane del 26 Giugno 2002
#Parte R

#Esercizio 1

#a
#funzione : gamsim
gamsim <- function(n,shape,scale) {
    par(mfrow=c(1,1))
    campione <- rgamma(n,shape,scale)
    hist(campione,main=paste("Campione simulato da rgamma(",n,",",shape,",",scale,")"),col="lightblue")
    print(paste("La Media risulta : ",mean(campione)))
    print(paste("La Varianza risulta:",var(campione)))
    return(campione)
}

#b
#media : 0.498839639181805
#varianza : 0.456570712283913

#c
simula <- function(n,shape=2,scale=1) {
    par(mfrow=c(2,2))
    for (i in 1:4) {
        campioni<-rgamma(n,shape,scale)
        plot(campioni,main=paste("Campione :",i));
        print(paste("La Media del campione: ",i," risulta : ",mean(campioni)))
        print(paste("La Varianza del campione: ",i," risulta:",var(campioni)))
    }#for
}#simula
#[1] "La Media del campione:  1  risulta :  2.08878794133435"
#[1] "La Varianza del campione:  1  risulta: 2.03944107555959"
#[1] "La Media del campione:  2  risulta :  1.89243330787259"
#[1] "La Varianza del campione:  2  risulta: 1.78017058391227"
#[1] "La Media del campione:  3  risulta :  1.92179938549538"
#[1] "La Varianza del campione:  3  risulta: 2.50470007715109"
#[1] "La Media del campione:  4  risulta :  2.04747906507082"
#[1] "La Varianza del campione:  4  risulta: 1.99839061057515"


#d
simula.param1 <- function(n,shape=c(0.5,2,5,10),scale=1) {
    par(mfrow=c(2,2))
    for (i in 1:4) {
        campioni<-rgamma(n,shape[i],scale)
        plot(campioni,main=paste("Campione :",i," rgamma(",n,",",shape[i],",",scale,")"));
        print(paste("La Media del campione: ",i," risulta : ",mean(campioni)))
        print(paste("La Varianza del campione: ",i," risulta:",var(campioni)))
    }#for
}#simula

#e
simula.param2 <- function(n,shape=2,scale=c(0.5,1,5,10)) {
    par(mfrow=c(2,2))
    for (i in 1:4) {
        campioni<-rgamma(n,shape,scale[i])
        plot(campioni,main=paste("Campione :",i," - rgamma(",n,",",shape,",",scale[i],")"));
        print(paste("La Media del campione: ",i," risulta : ",mean(campioni)))
        print(paste("La Varianza del campione: ",i," risulta:",var(campioni)))
    }#for
}#simula
#[1] "La Media del campione:  1  risulta :  3.93854182425892"
#[1] "La Varianza del campione:  1  risulta: 8.29443451902687"
#[1] "La Media del campione:  2  risulta :  1.92290677588451"
#[1] "La Varianza del campione:  2  risulta: 1.80703254211685"
#[1] "La Media del campione:  3  risulta :  0.39380157333588"
#[1] "La Varianza del campione:  3  risulta: 0.0728282103517645"
#[1] "La Media del campione:  4  risulta :  0.205239584622278"
#[1] "La Varianza del campione:  4  risulta: 0.0209538040878053"

#f commento
par(mfrow=c(1,1))

#Esercizio 2

#a

dati<-c(4.4,4.4,4.5,5.3,5.6,6.3,6.5,6.7,6.7,7.1,7.4,7.9,8.2,11.6,11.6,12.5,14.1,19.8,19.8,27.1)

nlv <- function(x,theta) {
    return(-x[1] * log(2+theta) - x[2] * log(1-theta) - x[3] * log(theta))
}#nlv



#b
#nlv(0.3,c(125,38,34))
#[1] -49.62492

#c
plot.vero <- function(x=c(125,38,34)) {
    n <- (0:10000)/10000
    a<-optim(.3, nlv,x=c(125,38,34))$value
    plot(n,nlv(x,n)-a,col=2,xlim=range(n),xlab="theta",ylab="log-verosimiglianza",type="l",ylim=c(0,qchisq(0.9999,1)))
}#plot.vero

#d - CONTROLLARE
optim(.3, nlv,x=c(125,38,34))

#e
stampa <-function(dati=c(125,38,34)) {
    par(mfrow=c(1,1))
    plot.vero(dati)
    val <-optim(.3, nlv,x=dati)
    abline(v=val$par,col="red",lty="dotted")
}#stampa

#f
intervallo <- function(dati=c(125,38,34),q=.95,df=1) {
    par(mfrow=c(1,1))
    stampa(dati)
    abline(h=qchisq(q,df)/2,col=2)
    x<-locator(2)
    abline(v=x$x)
    return(paste("Intervallo",x$x))
}#intervallo