/*---------------------------Corso SAS - 2003---------------------------------*/
/* Mauro Malvestio - 473678/STI - mauromalvestio@tiscali.it                   */
/* File : esecizi sas malvestio.sas                                           */
/* Docente: Dott.ssa: Silvia Sartorelli                                       */

/*----------------------------------------------------------------------------*/
/*- ----------------------Esercizi di Acquisizione ---------------------------*/
/*----------------------------------------------------------------------------*/

/* Setta il lib path */ 
LIBNAME lib 'c:\utenti\lab';

/* ESERCIZIO a1 --------------------------------------------------------------*/
DATA lib.case1;
INFILE 'i:\lab2003\case1.txt' FIRSTOBS=3;
INPUT codice zona $7-17 prezzo stanze eta riscal $;
RUN;

/* ESERCIZIO a2 --------------------------------------------------------------*/
DATA lib.case2;
INFILE 'i:\lab2003\case2.txt' FIRSTOBS=3;
INPUT codice zona $7-17 prezzo 21-23 stanze 27 eta 31-32 riscal $35-36;
RUN;

/* ESERCIZIO a3 --------------------------------------------------------------*/
DATA case3;
INFILE 'i:\lab2003\case3.txt' FIRSTOBS=3 MISSOVER; /* | TRUNCOVER */
INPUT codice zona $7-17 prezzo 21-23 stanze 27 eta 31-32 @34 riscal $;
RUN; /* Visto che la riga 12 possiede un CR .. */
proc fsview data=case3; /* .. prima della fine, va a capo in anticipo .. */
RUN; /* .. sfalsando la lettura ..*/

/* ESERCIZIO a4 --------------------------------------------------------------*/
DATA lib.case3;
INFILE 'i:\lab2003\case2.txt' FIRSTOBS=3;
INPUT codice stanze 27 prezzo 21-23;
RUN;

/* ESERCIZIO a5 --------------------------------------------------------------*/
DATA lib.regioni90;
INFILE 'i:\lab2003\regioni90.txt' FIRSTOBS=3;
INPUT @22 campeggi letti alloggi l_alloggi altri letti_altri;
RUN;

/* ESERCIZIO a6 --------------------------------------------------------------*/
DATA lib.regioni87;
INFILE 'i:\lab2003\regioni87.txt' FIRSTOBS=4;
INPUT @24 campeggi letto letto_alloggi letto_altri;
RUN;

/* ESERCIZIO a7 --------------------------------------------------------------*/
DATA lib.pane;
INFILE 'i:\lab2003\pane.txt';
INPUT fibra $1-11 tipo 13 diff 28-34 problem $36-44;
RUN;

/* ESERCIZIO a8 --------------------------------------------------------------*/
DATA lib.alcol;
INFILE 'i:\lab2003\alcol.txt' FIRSTOBS=2;
INPUT @6 region$ :15. alcohol tobacco;
RUN;

/* ESERCIZIO a9 --------------------------------------------------------------*/
DATA lib.hotdog;
INFILE 'i:\lab2003\hotdog.txt' FIRSTOBS=2;
INPUT @6 types $ :7. calories sodium;
RUN;

/* ESERCIZIO a10 -------------------------------------------------------------*/
DATA lib.proteine;
INFILE 'i:\lab2003\proteine.txt' FIRSTOBS=2;
INPUT @6 country$ :15. redmeat whitemeat eggs milk fish cereals starch nuts 
      frveg;
RUN;

/* ESERCIZIO a11 -------------------------------------------------------------*/
DATA lib.crashtest;
INFILE 'i:\lab2003\crashtest.txt' FIRSTOBS=2;
INPUT marca $ :19. modello $ :23. id $ :23. idy $ :26. testa toracica gambadx
      gambasx mpos $ :9. prot $ :15. porte anno peso tipo $;
RUN;

/* ESERCIZIO a12 -------------------------------------------------------------*/
DATA lib.prezzicase;
INFILE 'i:\lab2003\prezzi case.txt' FIRSTOBS=2;
INPUT @6 PRICE SQFT AGE_ FEATS NE_ CUST COR TAX;
RUN;

/* ESERCIZIO a13 -------------------------------------------------------------*/
DATA lib.elezioni87;
INFILE 'i:\lab2003\el87.txt' FIRSTOBS=3;
INPUT N @4 PROVINCIA$ :14. ETOT VTOT DC PCI PSI LLOMB LVEN VALIDI;
RUN;
DATA lib.elezioni92;
INFILE 'i:\lab2003\el92.txt' FIRSTOBS=3;
INPUT N @4 PROVINCIA$ :14. ELM ELF ETOT VOM VOF VTOT DC PDS RIF PSI LLOMB 
      VALIDI;
RUN;

/* ESERCIZIO a14 -------------------------------------------------------------*/
DATA mal_anagrafica;
INFILE 'i:\lab2003\malattie-anagrafica.txt' FIRSTOBS=2;
INPUT codice eta peso alt v4 sex;
RUN;

/* ESERCIZIO a15 -------------------------------------------------------------*/
DATA mal_dic;
INFILE 'i:\lab2003\malattie-dicotomiche.txt' FIRSTOBS=2 DELIMITER='09'x;
INPUT codice v1 v2 v3 v4 v5 v6 v7 v8 v9 v10 v11 v12 v13 v14 v15 v16;
RUN;

/* ESERCIZIO a16 -------------------------------------------------------------*/
DATA letturat;
INFILE 'i:\lab2003\lettura-t.csv' FIRSTOBS=2 DELIMITER=';';
INPUT Treatment $ Response;
RUN;

/* ESERCIZIO a17 -------------------------------------------------------------*/
DATA letturac;
INFILE 'i:\lab2003\lettura-c.csv' FIRSTOBS=2 DELIMITER=';';
INPUT Treatment $ Response;
RUN;

/* ESERCIZIO a18 -------------------------------------------------------------*/
DATA cervello;
INFILE 'i:\lab2003\cervello.txt' FIRSTOBS=2;
INPUT @6 Gender $ FSIQ VIQ PIQ _Weight _Height MRI_Count;
RUN;

/* ESERCIZIO a19 -------------------------------------------------------------*/
DATA miliardari;
INFILE 'i:\lab2003\miliardari.txt' FIRSTOBS=2;
INPUT @6 wealth _age $ 14 region $ 22;
RUN;

/* ESERCIZIO a20 -------------------------------------------------------------*/
DATA spesa;
INFILE 'i:\lab2003\spesa.txt' FIRSTOBS=2;
INPUT @6 EX ECAB MET GROW YOUNG OLD WEST STATE $;
RUN;

/* ESERCIZIO a21 -------------------------------------------------------------*/
DATA atletica;
INFILE 'i:\lab2003\atletica.txt' FIRSTOBS=2 DELIMITER='09'x;
INPUT Country $ :18. _100m _200m _400m _800m _1500m _5K _10K _Marathon;
RUN;


/*----------------------------------------------------------------------------*/
/*- -------------------------Esercizi di Unione ------------------------------*/
/*----------------------------------------------------------------------------*/

/* ESERCIZIO u1 --------------------------------------------------------------*/
DATA regioni90;
INFILE 'i:\lab2003\regioni90.txt' FIRSTOBS=3;
INPUT nome $ 1-21 @ 22 campeggi_90 letti_90 alloggi_90 l_alloggi_90 altri_90 
      letti_altri_90;
RUN;
DATA regioni87;
INFILE 'i:\lab2003\regioni87.txt' FIRSTOBS=4;
INPUT nome $ 1-21 @ 22 campeggi_87 letto_87 letto_alloggi_87 letto_altri_87;
RUN;
PROC SORT DATA=regioni87 OUT=regioni87;
by nome;
RUN;
PROC SORT DATA=regioni90 OUT=regioni90;
by nome;
RUN;
DATA regioni;
MERGE regioni87 regioni90;
by nome;
RUN;

/* ESERCIZIO u2 --------------------------------------------------------------*/
/* Ricordati di rinominare!!! ------------------------------------------------*/
DATA mal_anagrafica;
INFILE 'i:\lab2003\malattie-anagrafica.txt' FIRSTOBS=2;
INPUT codice eta peso alt _v4 sex;
RUN;
DATA mal_dic;
INFILE 'i:\lab2003\malattie-dicotomiche.txt' FIRSTOBS=2 DELIMITER='09'x;
INPUT codice v1 v2 v3 v4 v5 v6 v7 v8 v9 v10 v11 v12 v13 v14 v15 v16;
RUN;
PROC SORT DATA=mal_anagrafica OUT=mal_anagrafica;
by codice;
RUN;
PROC SORT DATA=mal_dic OUT=mal_dic;
by codice;
RUN;
DATA malattie;
MERGE mal_anagrafica mal_dic;
by codice;
RUN;

/* ESERCIZIO u3 --------------------------------------------------------------*/
DATA letturat;
INFILE 'i:\lab2003\lettura-t.csv' FIRSTOBS=2 DELIMITER=';';
INPUT Treatment $ Response;
RUN;
DATA letturac;
INFILE 'i:\lab2003\lettura-c.csv' FIRSTOBS=2 DELIMITER=';';
INPUT Treatment $ Response;
RUN;
DATA lettura;
SET letturat letturac;
RUN;

/* ESERCIZIO u4 --------------------------------------------------------------*/
DATA elezioni87;
INFILE 'i:\lab2003\el87.txt' FIRSTOBS=3;
INPUT N @4 PROVINCIA $ :14. ETOT_87 VTOT_87 DC_87 PCI_87 PSI_87 LLOMB_87 
           LVEN_87 VALIDI_87;
VOTI_DC_87    = (DC_87/VALIDI_87)*100;
VOTI_PCI_87   = (PCI_87/VALIDI_87)*100;
VOTI_PSI_87   = (PSI_87/VALIDI_87)*100;
VOTI_LLOMB_87 = (LLOMB_87/VALIDI_87)*100;
VOTI_LVEN_87  = (LVEN_87/VALIDI_87)*100;
RUN;
DATA elezioni92;
INFILE 'i:\lab2003\el92.txt' FIRSTOBS=3;
INPUT N @4 PROVINCIA $ :14. ELM_92 ELF_92 ETOT_92 VOM_92 VOF_92 VTOT_92 DC_92 
           PDS_92 RIF_92 PSI_92 LLOMB_92 VALIDI_92;
VOTI_DC_92    = (DC_92/VALIDI_92)*100;
VOTI_PDS_92   = (PDS_92/VALIDI_92)*100;
VOTI_RIF_92   = (RIF_92/VALIDI_92)*100;
VOTI_PSI_92   = (PSI_92/VALIDI_92)*100;
VOTI_LLOMB_92 = (LLOMB_92/VALIDI_92)*100;
RUN;
PROC SORT DATA=elezioni87 OUT=elezioni87;
by PROVINCIA;
RUN;
PROC SORT DATA=elezioni92 OUT=elezioni92;
by PROVINCIA;
RUN;
DATA elezioni;
MERGE elezioni87 elezioni92;
by PROVINCIA;
RUN;

/*----------------------------------------------------------------------------*/
/*------------------------Esercizi di Trasformazione--------------------------*/
/*----------------------------------------------------------------------------*/

/* ESERCIZIO t1 --------------------------------------------------------------*/
DATA malattie;
SET malattie;
corporeita = peso / (alt /100 ) ** 2;
select;
    when (corporeita <= 18) 
        classe = "sotto peso"; 
    when (corporeita > 18 & corporeita <= 24) 
        classe = "normo pesp"; 
    when (corporeita > 25 & corporeita <= 29) 
        classe = "sovrappeso"; 
    otherwise
        classe = "obeso";
end; 
totale = v1+v2+v3+v4+v5+v6+v7+v8+v9+v10+v11+v12+v13+v14+v15+v16;
RUN;

/* ESERCIZIO t2 --------------------------------------------------------------*/
DATA cervello;
SET cervello;
conto = FLOOR(FSIQ/100) + FLOOR(VIQ/100) + FLOOR(PIQ/100);
RUN;

/* ESERCIZIO t3 --------------------------------------------------------------*/
DATA cervello;
SET cervello;
_Weight = _Weight*0.4539;
_Height = _Height*2.5;
RUN;

/* ESERCIZIO t4 --------------------------------------------------------------*/
DATA cervello;
SET cervello;
media = mean(FSIQ,VIQ,PIQ);
select;
    when (media <= 85) 
        classe = "CLASSE_A"; 
    when (media > 85 & media < 115)
        classe = "CLASSE_B"; 
    when (media >= 85)
        classe = "CLASSE_C"; 
end; 
RUN;

/* ESERCIZIO t5 --------------------------------------------------------------*/
DATA lib.cervello;
INFILE 'i:\lab2003\cervello.txt' FIRSTOBS = 2;
INPUT @6 sesso $ FSIQ VIQ PIQ peso altezza pixel;
RUN;

PROC SORT DATA = lib.cervello OUT = lib.cervello;
BY FSIQ;
RUN;
DATA lib.cervello;
SET lib.cervello;
RETAIN rango_FSIQ  0;
rango_FSIQ = rango_FSIQ +1;
RUN;
PROC SORT DATA = lib.cervello OUT = lib.cervello;
BY VIQ;
RUN;
DATA lib.cervello;
SET lib.cervello;
RETAIN rango_VIQ  0;
rango_VIQ = rango_VIQ +1;
RUN;
PROC SORT DATA = lib.cervello OUT = lib.cervello;
BY PIQ;
RUN;
DATA lib.cervello;
SET lib.cervello;
RETAIN rango_PIQ  0;
rango_PIQ = rango_PIQ +1;
RUN;

/* ESERCIZIO t5 -----------------------------------------RANKED VERSION-------*/
PROC RANK data=lib.cervello out=lib.cervello_rank TIES=HIGH;
by notsorted;
var FSIQ VIQ PIQ; 
ranks rango_FSIQ rango_VIQ rango_PIQ;
run;